<!DOCTYPE html>
<HTML LANG="en">
define(`_TITLE', `guide to software')dnl
define(`_DESCRIPTION', `do not read')dnl
define(`_PAGE', `software/')dnl
define(`_STYLE', `')dnl
include(`../html.m4')dnl
include(`../head.m4')dnl
<BODY>
include(`../navreturn.m4')dnl
<H1>software</H1>
_BAR
<H2>Foreword</H2>
<P>
Due to the majority of designers having typical ability, use of computers may be significantly more challenging for users with disabilities, especially affecting sight and reading.
Change in this regard for those that simply lack the facilities to read but have the patience to do so is inevitable but slow, with current measures being proprietary (designed first to make money and second for function) or sorely lacking in actual useability.
Helping users with a deeper inability to read extensively is a tougher problem to which the solution may not yet be known even vaguely.
The only advice I can offer is that everyone should, until the point at which it harms others, see to the removal of obstacles to their ability, without hesitation or apology.
If you give up on computing, so be it.
There are more valuable things to explore in life.
</P>
<P>
Computers encase lightning within sand with the purpose of creating a lifelike inanimate robot that can consider particularly boring thought.
Measures should be taken to avoid attachment, whether mental, emotional, or physical, to computers.
Caution can accompany admiration.
Ultimately, the humans were the ones that produced the computers, and computers amplify human flaws as well as human feats.
Try to be kind to everyone but don't take anything too seriously.
</P>
<P>
This guide encompasses usage of IBM-compatible, amd64 processor architecture computers, particularly with POSIX and other UNIX-like operating systems like Linux and DragonflyBSD.
Non-standard, proprietary operating systems such as Microsoft Windows or OS/2 are out of scope.
</P>

<H2>UNIX</H2>
<UL>
<LI>_hyperlink(`https://en.wikipedia.org/wiki/Unix', `Unix') (Wikipedia)</LI>
<LI>_hyperlink(`https://github.com/dspinellis/unix-history-repo', `unix-history-repo') (GitHub)</LI>
</UL>

<H2>Advanced Configuration and Power Interface</H2>
<UL>
<LI><A HREF="https://en.wikipedia.org/wiki/Advanced_Configuration_and_Power_Interface">Advanced Configuration and Power Interface</A> (Wikipedia)</LI>
</UL>
<P>
The Advanced Configuration and Power Interface, or ACPI, is the interface through which the operating system and client programs can control features in your computer's firmware.
Usually this is used with an ACPI client or opaquely controlled by the operating environment.
</P>
<P>
On Linux, _code(`acpi(1)') can be used to read and control ACPI events manually.
_code(`<A HREF="https://sourceforge.net/projects/acpid2/">acpid</A>(8)'), _code(`<A HREF="#logind">elogind</A>(8)'),
SystemD, and many desktop environments can control the ACPI automatically.
</P>
<P>
On NetBSD, see _code(`acpi(4)').
</P>


<H2>C Language</H2>
<P>
For compilation, _code(`tcc(1)'), _code(`gcc(1)'), and _code(`clang(1)') are all reasonable choices depending on your needs.
</P>
<P>
On Alpine Linux, the standard library headers are in the _code(`musl-dev') package.
</P>
<P>
In most system package managers, standard library documentation can be found in the _code(`man-pages') and _code(`man-pages-posix') packages.
</P>
<P>
Many Linux software distributions' system package managers have meta-packages that pull all necessities for C development as dependencies.
Alpine has _code(`build-base') and Debian has _code(`build-essential').
</P>


<H2>echo(1)</H2>
<UL>
<LI><A HREF="https://www.in-ulm.de/~mascheck/various/echo+printf/">Variations in echo implementations</A></LI>
</UL>
<P>
Don't use _code(`echo(1)'), use _code(`printf(1)').
_code(`printf(1)') simulates the _code(`printf(3)') function in the C standard I/O library which has no significant variations, whereas the functionality of _code(`echo(1)') can vary between vendors.
The following _code(`sh(1)') program provides _code(`echo(1)') through _code(`printf(1)'):
</P>
<PRE>
#!/bin/sh
printf "%s" "$*"
</PRE>

<H2 ID="find">find(1)</H2>
<UL>
<LI><A HREF="https://en.wikipedia.org/wiki/Find_(Unix)">find</A> (Wikipedia</LI>
</UL>

<H2 ID="fonts">Fonts</H2>

<H2 ID="fstab">fstab</H2>
<P>See _code(`fstab(5).')</P>
<P>postmarketOS requires that the _code(`localmount') OpenRC service be enabled for the system to read _code(`fstab(5)').
<P>Arch and Artix have fstab generators at _code(`genfstab(8)') and _code(`fstabgen(8)') respectively in their installation scripts.</P>

<H2 ID="linux">Linux</H2>
<UL>
<LI><A HREF="http://tldp.yolinux.com/HOWTO/subdir/HOWTO-INDEX.html">How to Linux</A></LI>
<LI><A HREF="https://christine.website/blog/howto-usermode-linux-2019-07-07">How to Use User Mode Linux</A></LI>
<LI><A HREF="https://www.cs.cmu.edu/~awb/linux.history.html">LINUX's History</A></LI>
<LI><A HREF="https://www.kernel.org/doc/html/v4.17/index.html">The Linux Kernel documentation</A></LI>
<LI><A HREF="https://groups.google.com/g/comp.os.minix/c/wlhw16QWltI">LINUX is obsolete</A></LI>
<LI><A HREF="http://www.linuxfromscratch.org/">Linux From Scratch</A></LI>
<LI><A HREF="https://www.redhat.com/sysadmin/bios-uefi">Move your Linux from BIOS to UEFI in place</A></LI>
<LI><A HREF="https://www.collabora.com/news-and-blog/blog/2020/08/27/using-the-linux-kernel-case-insensitive-feature-in-ext4/">Using the Linux kernel's Case-insensitive feature in Ext4</A></LI>
</UL>
<H3>Audio</H3>
<P>
Most audio servers recommend that they be run in userspace with user privileges, with PulseAudio going so far as to exiting when run as root without additional configuration.
The Alpine wiki currently recommends _code(`pipewire(1)'), with postmarketOS, which is based on Alpine, coming pre-configured with PipeWire.
PipeWire is relatively new and the typical audio server used is PulseAudio; Debian and many popular Debian-based distributions come pre-configured with PulseAudio.
</P>
<H4>ALSA</H4>
<UL>
<LI><A HREF="https://wiki.alpinelinux.org/wiki/Main_Page/Adding_sound">Adding sound</A> (Alpine Linux Wiki)</LI>
<LI><A HREF="https://bbs.archlinux.org/viewtopic.php?id=256857">ALSA lib conf Evaluate error</A></LI>
<LI><A HREF="https://dev.to/setevoy/linux-alsa-lib-pcmdmixc1108sndpcmdmixopen-unable-to-open-slave-38on">ALSA lib pcm_dmix.c:1108:(snd_pcm_dmix_open) unable to open slave</A></LI>
</UL>
<P>
The Alpine wiki ("Adding sound") says to install _code(`alsa-conf'), _code(`alsa-lib'), and _code(`alsa-utils'),
add yourself to the _code(`audio') group, and then do some more configuration that I've never needed to do:
Use _code(`alsamixer(1)') to find a working sound card (press _code(`F6') from the first screen ALSAMixer presents)
and edit _code(`/usr/share/alsa/alsa.conf') and change _code(`defaults.ctl.card') and _code(`defaults.pcm.card') to the sound card that works.
</P>
<P>
The Alpine wiki doesn't mention this but you'll need to enable the _code(`alsa') OpenRC service and either start it or reboot.
I also installed _code(`gstreamer') but I don't know why.
</P>
<P>
ALSA is clunky, many people prefer to use a frontend such as Pipewire or PulseAudio that exposes its own interface while remaining compatible with ALSA.
</P>
<H4>OSS</H4>
<P>
Deprecated, unfortunately.
</P>
<H4>PipeWire</H4>
<UL>
<LI><A HREF="https://wiki.alpinelinux.org/wiki/PipeWire">PipeWire</A> (Alpine Linux Wiki)</LI>
<LI><A HREF="https://gitlab.freedesktop.org/pipewire/pipewire/-/wikis/home">PipeWire</A> (FreeDesktop Wiki)</LI>
</UL>
<P>
Provided by the _code(`pipewire') package on Alpine.
</P>
<PRE>
RTKit error: org.freedesktop.DBus.Error.ServiceUnknown
</PRE>
<P>
This means you need _code(`rtkit') installed and running through your initialization system.
</P>
<H4>PulseAudio</H4>
<P>
On Alpine you'll need the _code(`pulseaudio'), _code(`pulseaudio-alsa'), and _code(`alsa-plugins-pulse') packages for PulseAudio with ALSA compatibility.
Start _code(`pulseaudio(1)') when you want audio, ideally in your _code(`.xinitrc').
</P>

<H3>Distribution</H3>
<P>
Linux is usually obtained as part of a software distribution put together to form a useable operating system.
</P>

<H4>Alpine</H4>
<UL>
<LI><A HREF="https://pkgs.alpinelinux.org/contents">Alpine repositories content search</A></LI>
</UL>
<H5>Always install manual pages</H5>
<P>
Alpine doesn't include man pages in program packages to save on space, instead keeping them in _code(`[<I>package</I>]-doc') sibling packages.
To always install doc packages with program packages, _code(`apk add docs').
</P>

<H4>Arch</H4>
<P>
Arch is known for using the latest versions of programs, which has given it an undeserved reputation of instability.
</P>
<H5>Bootstrapping</H5>
<P>
Use _code(`pacstrap(8)').
</P>
<P>
At a minimum you need the _code(`base') package.
Select a kernel and install the corresponding package; _code(`linux'), _code(`linux-lts'), or another Linux configuration or fork.
The Arch wiki says you need to install _code(`linux-firmware'), this isn't strictly necessary but it is recommended.
Install _code(`base-devel') if you plan on using the AUR or if you don't know what the AUR is yet.
</P>
<P>
It's also a good idea to install any utilities you'll need on the bootstrapped system.
Text editors, network managers or utilities, and other administration tools, for example.
Manual utilities such as _code(`man-db') and others would also be useful.
</P>
<H5>Ubiquitous packages missing</H5>
<P>From the anals of my notes, 2021-06-04:</P>
<PRE>
Had an issue with pacman missing some ubiquitous packages (esr's `ascii`, xorg-xev, etc).
This fixed it. I don't really know why - maybe some issues with my repos?
This was cleanly installed artix-openrc.

[5:46 PM] Bassman Leyla: So what I did is I went into /etc/pacman.d/mirrorlist-arch and uncommented a local mirror
[5:46 PM] Bassman Leyla: Then I appended a config block a package maintainer gave me onto /etc/pacman.conf
[5:46 PM] Bassman Leyla: I'll paste it in
[5:47 PM] Bassman Leyla:
```
#
# ARCHLINUX
#

#[testing]
#Include = /etc/pacman.d/mirrorlist-arch

[extra]
Include = /etc/pacman.d/mirrorlist-arch

#[community-testing]
#Include = /etc/pacman.d/mirrorlist-arch

[community]
Include = /etc/pacman.d/mirrorlist-arch

#[multilib-testing]
#Include = /etc/pacman.d/mirrorlist-arch

#[multilib]
#Include = /etc/pacman.d/mirrorlist-arch
```
</PRE>
<H4>Artix</H4>
<UL>
<LI><A HREF="https://artixlinux.org/">Artix Linux</A></LI>
<LI><A HREF="https://en.wikipedia.org/wiki/Artix_Linux">Artix Linux</A> (Wikipedia)</LI>
</UL>
<P>
Artix refers to the series of Arch derivatives which use initialization systems other than SystemD's.
</P>
<H5>Bootstrapping</H5>
<P>
This process differs from Arch's bootstrapping process.
Artix uses _code(`basestrap(8)') rather than _code(`pacstrap(8)');
you need to select the initialization you want to use: _code(`66'), _code(`dinit'), _code(`openrc'), _code(`runit'), or _code(`s6-base'), as a package separate from _code(`base');
and Artix's official wiki says you need to install the appropriate <A HREF="#logind">_code(`elogind')</A> package (_code(`elogind-[<I>initialization system</I>]') e.g. _code(`elogind-66')) but like _code(`linux-firmware') though it is helpful it isn't strictly necessary.
</P>

<H4>Debian</H4>
<UL>
<LI><A HREF="https://www.debian.org/">Debian</A></LI>
<LI><A HREF="https://en.wikipedia.org/wiki/Debian">Debian</A> (Wikipedia)</LI>
</UL>
<P>
Debian is known for its stability and longevity.
Debian uses SystemD as its initialization system, the GNU core utilities, and dpkg and apt for package management.
</P>
<P>
While it's possible to use non-Linux kernels within Debian, it's uncommon and the only non-Linux option currently maintained is the GNU HURD microkernel.
</P>
<P>
<A HREF="#pkgsrc">pkgsrc</A> can be used on Debian.
</P>

<H4>postmarketOS</H4>
<P>
postmarketOS is an Alpine-based Linux software distribution that makes configuring and using Linux easy on mobile devices.
</P>
<H5>Random MAC address generation on Wifi</H5>
<P>
By default, postmarketOS will generate a random software MAC address when connecting to a new WLAN network.
You can disable this by adding a NetworkManager rule.
In _code(`/etc/NetworkManager/conf.d/') you can make a file with any name that has the following:
</P>
<PRE>
[device]
wifi.scan-rand-mac-address=no
</PRE>
<P>
On a live system you can then _code(`rc-service networkmanager restart') to restart NetworkManager and have it load the new configuration.
</P>

<H4>Ubuntu</H4>
<UL>
<LI><A HREF="https://securitylab.github.com/research/Ubuntu-gdm3-accountsservice-LPE/">How to get root on Ubuntu 20.04 by pretending nobody's /home</A></LI>
</UL>
<P>
Ubuntu is a derivative of Debian.
</P>

<H3 ID="logind">logind</H3>
<UL>
<LI><A HREF="https://github.com/elogind/elogind">elogind</A></LI>
<LI><A HREF="https://wiki.gentoo.org/wiki/Elogind">elogind</A> (Gentoo Wiki)</LI>
<LI><A HREF="https://www.freedesktop.org/software/systemd/man/org.freedesktop.login1.html">org.freedesktop.login1</A></LI>
<LI><A HREF="https://nixos.wiki/wiki/Logind">logind</A> (NixOS Wiki)</LI>
</UL>
<P>
logind (_code(`systemd-logind.service(8)')) is a component of SystemD that exposes information about active users on the system via the org.freedesktop.login1 D-Bus interface which is used by the popular desktop environments GNOME and KDE.
It also handles <A HREF="#acpi">ACPI</A> events.
It can be configured in _code(`logind.conf(5)').
</P>
<P>
On systems without SystemD and with conflicting software, _code(`elogind(8)') may be used.
</P>

<H3>Xenia</H3>
<UL>
<LI><A HREF="http://yerf.metafur.org/date/1996-07-14">A hacker fox!</A></LI>
</UL>
<P>
Xenia was an entry for the Linux logo competition which Tux eventually won.
</P>


<H2>Make utility</H2>
<P>
_code(`make(1)') in modern times is fragmented into the GNU version (in context, <I>_code(`gmake')</I>) and the {Free,Open,Net}BSD version (<I>_code(`bmake')</I>).
Complex Makefiles may not be useable in both.
It's custom for Linux systems to have _code(`make(1)') as GNU Make and _code(`bmake(1)') as BSD Make, and BSD-based systems to have _code(`make(1)') as BSD Make and _code(`gmake(1)') as GNU Make.
</P>

<H2>On-line manual</H2>
<P>
In the context of POSIX and UNIX-like systems, an "on-line" manual is a manual that is accessible via the computer system it documents.
Particularly, the _code(`man(1)') utility and the manual "pages" it references.
</P>
<P>
Alpine by default uses _code(`mandoc').
</P>

<H2>Paging</H2>
<P>
_code(`less(1)') is _code(`more(1)'); more or less.
</P>

<H2 ID="partitioning">Partitions and filesystems</H2>
<UL>
<LI><A HREF="https://wiki.archlinux.org/title/EFI_system_partition">EFI system partition (Arch Wiki)</A></LI>
<LI><A HREF="https://wiki.artixlinux.org/Main/Installation#Partition_your_disk_.28BIOS.29">Installation#Partition your disk - Artix wiki</A></LI>
<LI><A HREF="https://wiki.archlinux.org/title/Installation_guide#Partition_the_disks">Installation guide#Partition the disks - Arch wiki</A></LI>
</UL>
<P>
Don't use partitioners included with OS media where the same job can be done by <A HREF="https://gparted.org/">GParted</A> (which has live media available) or another good general-purpose partitioner.
BSDs and Plan 9 are exceptions to this rule due to their exotic partitioning systems.
Using utilities from a shell or TUIs does not make you "cooler" than someone who needs a GUI for partitioning; in some cases, messing up partitioning can have serious consequences, so it's always nice to have some idiot-proofing.
I always partition my disks with the GParted live media.
</P>
<P>
You should do your own research on how you should partition your disks.
I personally use separate partitions for /boot, /home, /, and swap.
Your needs will vary.
</P>
<P>
<B>Please note that a separate boot partition is mandatory if you intend to boot via (U)EFI.</B>
Check out the linked pages in the "See also" section.
</P>
<P>
Use _code(`mkfs(8)') for creating filesystems and _code(`mount(8)') for mounting partitions' filesystems.
</P>
<H3>gpart</H3>
<UL>
<LI><A HREF="https://en.wikipedia.org/wiki/Gpart">Gpart</A> (Wikipedia)</LI>
</UL>
<P>
Available as _code(`sysutils/gpart') in pkgsrc.
</P>
<P>
_code(`gpart(8)') is a tool that scans a file (or block device presented as a file) for drive partitions regardless of any table present on the medium.
</P>
<H3 ID="luks">LUKS</H3>
<UL>
<LI><A HREF="https://www.howtoforge.com/automatically-unlock-luks-encrypted-drives-with-a-keyfile/">Automatically Unlock LUKS Encrypted Drives With A Keyfile</A></LI>
<LI><A HREF="https://wiki.gentoo.org/wiki/Dm-crypt">Dm-crypt</A> (Gentoo Wiki)</LI>
<LI><A HREF="https://www.cyberciti.biz/security/how-to-backup-and-restore-luks-header-on-linux/">How to backup and restore LUKS header on Linux</A></LI>
<LI><A HREF="https://devconnected.com/how-to-encrypt-partition-on-linux/">How To Encrypt Partition on Linux</A></LI>
<LI><A HREF="https://unixfuntime.wordpress.com/2012/08/20/luks-passphrases-changing-adding-removing/">LUKS passphrases: Changing, adding, removing</A></LI>
<LI><A HREF="https://wiki.alpinelinux.org/wiki/LVM_on_LUKS">LVM on LUKS</A> (Alpine Wiki)</LI>
</UL>
<P>
_code(`e2fsprogs') is needed for the _code(`dm_mod') kernel module used for LUKS partition decryption.
</P>
<P>
To format a partition to a LUKS volume, determine the physical block device location for that partition and run _code(`cryptsetup luksFormat [<I>partition</I>]').
The passphrase used can be changed or removed after creation.
</P>
<P>
To open a LUKS volume, use _code(`cryptsetup luksOpen [<I>partition</I>] [<I>name</I>]').
This <I>name</I> is the name the <I>decrypted block device</I> location will take in _code(`/dev/mapper/').
</P>
<P>
Before the decrypted block device has a filesystem it'll just be cleared space - format as normal but use the decrypted block device location.
</P>
<P>
To mount a partition in an opened LUKS volume, use _code(`mount(8)') as normal, just with the decrypted block device location.
</P>
<P>
To close an open LUKS volume, _code(`umount(8)') any mapped and mounted partitions from the volume and _code(`cryptsetup luksClose [<I>name</I>]').
</P>
<P>
To make the LUKS partition openable via keyfile, first make a keyfile (_code(`dd if=/dev/urandom of=/root/keyfile bs=1024 count=4') seems to work), and optionally make it readable by root only (_code(`chmod 0400 [<I>keyfile</I>]')).
Then add the keyfile to the partition's LUKS header with _code(`cryptsetup luksAddKey [<I>physical partition block device</I>] [<I>keyfile</I>]').
</P>
<H4>dm-crypt</H4>
<P>
_code(`dm-crypt') is a service that automatically mounts LUKS volumes at boot.
</P>
<P>
On most OpenRC-initialized distributions, the _code(`cryptsetup-openrc') package provides _code(`dmcrypt').
Make sure that service is added to runlevel boot.
</P>
<P>
Configuration is in _code(`/etc/conf.d/dmcrypt') and further configuration should be done in _code(`<A HREF="#fstab">fstab</A>').
_code(`dm-crypt') will need the UUID of the <I>physical</I> block device while fstab (if being configured with UUIDs will need the UUID of the decrypted block device in the device mapper.
</P>
<H3>TestDisk</H3>
<UL>
<LI><A HREF="https://en.wikipedia.org/wiki/TestDisk">TestDisk</A> (Wikipedia)</LI>
</UL>

<H2>NetBSD</H2>
<UL>
<LI><A HREF="http://netbsd.org/">netbsd.org</A></LI>
<LI><A HREF="https://www.netbsd.org/docs/guide/en/">NetBSD Guide</A></LI>
<LI><A HREF="https://www.netbsd.org/docs/pkgsrc/">pkgsrc Guide</A></LI>
</UL>
<H3>Battery</H3>
<P>_code(`envstat(1)') can show the current battery status.</P>
<H3>Mounting filesystems</H3>
<OL>
<LI>Connect the drive with the filesystem you want to access.</LI>
<LI>Use _code(`dmesg(8)') to determine the location in _code(`/dev/') of the disk.</LI>
<LI>_code(`disklabel(8)') the drive to determine which partition on the disk you want to access (_code(`disklabel /dev/<I>disk</I>'))</LI>
<LI>_code(`mount(8)') the filesystem.</LI>
<LI>_code(`umount(8)') the filesystem when done using it.</LI>
</OL>
<H4>ext4</H4>
<P>
Install _code(`filesystems/fuse') and _code(`filesystems/fuse-ext2').
_code(`disklabel(8)') will list ext4 filesystems as of type "Linux Ext2".
Use _code(`fuse-ext2(1)') to mount the filesystem.
</P>
<P>
_code(`fuse-ext2(1)') is spotty in places and may not work correctly.
</P>
<H4>exFAT</H4>
<P>
Install _code(`filesystems/fuse') and _code(`filesystems/fuse-exfat').
Use _code(`mount.exfat') to mount the filesystem (the manual page for which is _code(`mount.exfat-fuse(8)')).
</P>
<H3>Fix _code(`SSL certificate problem: unable to get local issuer certificate')</H3>
<UL>
<LI><A HREF="http://mail-index.netbsd.org/pkgsrc-users/2021/07/19/msg034147.html">Depending on security/ca-certificates?</A></LI>
<LI><A HREF="https://www.cambus.net/installing-ca-certificates-on-netbsd/">Installing CA certificates on NetBSD</A></LI>
<LI><A HREF="https://github.com/ohmyzsh/ohmyzsh/issues/8321#issuecomment-863493503">SSL Certificate Problem</A> (ohmyzsh/ohmyzsh#8321)</LI>
</UL>
<P>Install _code(`security/mozilla-rootcerts-openssl').</P>
<P>
<I>Do not</I> use SSL workarounds like (in the case of git) _code(`GIT_SSL_NO_VERIFY').
These leave your system open to man-in-the-middle attacks.
</P>
<H3>rc.d</H3>
<UL>
<LI><A HREF="http://www.mewburn.net/luke/papers/rc.d.pdf">The Design and Implementation of the NetBSD rc.d system</A></LI>
</UL>
<H3>System logging</H3>
<UL>
<LI><A HREF="https://www.unitedbsd.com/d/548-system-instability-on-unstable-version-how-do-i-get-logs/7">System instability on unstable version - how do I get logs?</A></LI>
</UL>
<P>See _code(`syslogd(8)') and _code(`syslog.conf(5)'), which pertain to system logging.</P>
<P>Setting _code(`DDB_ONPANIC') (see _code(`options(4)') and _code(`sysctl(8)')) will save a crash dump at _code(`/var/crash') on kernel panic.
<H3>Upgrading</H3>
<UL>
<LI>The NetBSD Guide - <A HREF="https://www.netbsd.org/docs/guide/en/chap-upgrading.html">Chapter 4: Upgrading NetBSD</A></LI>
<LI><A HREF="https://www.unitedbsd.com/d/110-upgrading-netbsd-using-sysinst">Upgrading NetBSD using sysinst</A></LI>
</UL>

<H2>PCI Utilities</H2>
<UL>
<LI><A HREF="https://github.com/pciutils/pciutils">pciutils/pciutils</A> (GitHub)</LI>
</UL>
<P>
Available as _code(`sysutils/pciutils') from pkgsrc.
Supplies _code(`lspci(8)'), _code(`setpci(8)'), and _code(`update-pciids(8)').
</P>
<P>
_code(`update-pciids(8)') is not part of the _code(`pciutils') package in Alpine Linux repositories.
</P>
<P>
NetBSD includes _code(`pcictl(8)') which offers similar functionality.
_code(`pcictl pci0 list') outputs roughly the same information as _code(`lspci(8)'), though _code(`lspci(8)') may offer slightly more detailed information.
</P>

<H2 ID="pkgsrc">pkgsrc</H2>
<UL>
<LI><A HREF="http://www.netbsd.org/docs/pkgsrc/"</A>the pkgsrc user's guide</A></LI>
</UL>
<H3>Upgrading packages</H3>
<UL>
<LI><A HREF="http://www.netbsd.org/docs/pkgsrc/using.html">Using pkgsrc</A> (the pkgsrc user's guide)</LI>
<LI><A HREF="https://wiki.netbsd.org/cgi-bin/cvsweb/wikisrc/pkgsrc/how_to_upgrade_packages.mdwn?rev=1.9;content-type=text%2Fx-cvsweb-markup">how to upgrade packages</A> (NetBSD Developer Wiki <B>snapshot; 2020-09-09</B>)</LI>
</UL>
<P>
See _code(`pkgtools/pkg_rolling_replace').
</P>

<H2 ID="power">Power settings</H2>
<P>
Power is managed by <A HREF="#acpi">ACPI</A>.
</P>

<H2>SSH keys</H2>
<UL>
<LI><A HREF="https://docs.github.com/en/authentication/connecting-to-github-with-ssh/adding-a-new-ssh-key-to-your-github-account">Adding a new SSH key to your GitHub account</A> (GitHub Docs)</LI>
<LI><A HREF="https://docs.github.com/en/authentication/connecting-to-github-with-ssh/checking-for-existing-ssh-keys">Checking for existing SSH keys</A> (GitHub Docs)</LI>
<LI><A HREF="Generating a new SSH key and adding it to the ssh-agent">Generating a new SSH key and adding it to the ssh-agent</A> (GitHub Docs)</LI>
</UL>
<P>SSH keys are typically stored in _code(`$HOME/.ssh').</P>
<P>Typically, the public key's filename will be suffixed with _code(`.pub'), while the private key will not.</P>
<P>You can generate an SSH key with _code(`ssh-keygen(1)'). Currently the preferred implementation is _code(`openssh-keygen'), part of the OpenSSH suite.</P>
<P>
Microsoft GitHub documentation suggests a user create a key with _code(`ssh-keygen -t ed25519 -C "[<I>e-mail address</I>]"').
This generates an <A HREF="https://en.wikipedia.org/wiki/EdDSA#Ed25519">Ed25519</A> SSH key with an e-mail address in the key comment.
</P>

<H2>Pronunciation</H2>
<UL>
<LI><A HREF="https://www.linux.org/threads/common-pronunciations-of-linux-directories-commands-etc.4445/">Common pronunciations of Linux directories, commands, etc</A></LI>
</UL>
<H2>Task management</H2>
<P>_code(`top(1)') comes with busybox, otherwise use _code(`htop').</P>

<H2 ID="text_editing">Text editing</H2>
<P>
_code(`nano(1)') is a text editor that's usually recommended for beginners because its controls are more intuitive.
_code(`ne(1)') is like _code(`nano(1)') but with different superpowers. Not yet in pkgsrc.
</P>
<H3>ed</H3>
<UL>
<LI><A HREF="https://catonmat.net/ftp/ed.text.editor.cheat.sheet.txt">Ed Cheat Sheet</A></LI>
</UL>
<P>
A particularly shoddy attempt at _code(`ed(1)') is provided by _code(`busybox').
A traditional _code(`ed(1)') implementation is in plan9ports.
I'm pretty sure some later UNIX-based OSes doubled the _code(`ed(1)') buffers, there's pretty much no downside to doing so in the modern era but it should be very easy to do yourself if it hasn't already been done (just double some of the array sizes in the beginning of _code(`ed.c')).
</P>
<H3>vi</H3>
<P>
Unlike _code(`busybox')'s _code(`ed(1)') implementation, its _code(`vi(1)') is very useable.
_code(`vim(1)') is a popular re-implementation of _code(`vi(1)').
</P>
<H3>emacs</H3>
<P>
Emacs ("editor macros") is a text editor with a very powerful Lisp interpreter included.
Lisp is mostly antiquated due to its undeserved lack of popularity.
Linus Torvalds uses his own fork of uEmacs ("micro Emacs"), an Emacs without the Lisp interpreter(?).
</P>
<H3>cat</H3>
<P>
Technically _code(`cat(1)') and other UNIX utilities can be used in a hacky way for text editing functions.
You'd be better off using _code(`ed(1)'); the UX is very similar.
</P>

<H2 ID="true">true(1)</H2>
<UL>
	<LI><A HREF="http://trillian.mit.edu/~jc/;-)/ATT_Copyright_true.html">CHAMBERS John - The /bin/true Command and Copyright</A></LI>
	<LI><A HREF="https://twitter.com/rob_pike/status/966896123548872705">PIKE Rob - "/bin/true used to be an empty file."</A></LI>
	<LI><A HREF="https://www.muppetlabs.com/~breadbox/software/tiny/teensy.html">RAITER Brian - A Whirlwind Tutorial on Creating Really Teensy ELF Executables for Linux</A></LI>
	<LI><A HREF="https://www.unix.com/man-page/posix/1p/true/">true(1p)</A> (The Open Group, 2003)</LI>
	<LI>Notable true implementations<UL>
		<LI><B>ongoing</B> started 1992 - <A HREF="https://www.gnu.org/">GNU</A>/<A HREF="https://www.gnu.org/software/coreutils/">coreutils</A> - <A HREF="https://git.savannah.gnu.org/cgit/coreutils.git/tree/src/true.c">src/true.c</A></LI>
		<LI><B>ongoing</B> forked from 4.4BSD-Lite2 - <A HREF="https://www.netbsd.org/">NetBSD</A>/<A HREF="https://github.com/NetBSD/src">src</A> - <A HREF="https://github.com/NetBSD/src/blob/trunk/usr.bin/true/true.sh">usr.bin/true/true.sh</A></LI>
	</UL></LI>
</UL>
<P>
_code(`true(1)') is a tool that <I>only</I> quits silently with an exit status of 0.
Similarly, _code(`false(1)') is a tool that <I>only</I> quits silently with an exit status of 1.
Recognizing arguments, printing to standard output, reading from standard input, or otherwise exiting with any other status of 0, is a violation of the POSIX specification for _code(`true(1)').
These utilities find use in shell scripting, which, though extremely relevant to these utilities, is beyond the scope of this article.
</P>
<P>
Because _code(`true(1)')'s required functionality is so simple a POSIX-compliant implementation is a one-liner in most languages, so long as you're willing to make an exception in your code styling.
For example, in C:
</P>
<PRE>
int main(void) { return 0; }
</PRE>
<P>
Because executing an empty shellscript file will in most shells do nothing and return an exit status of 0, technically an empty shellscript file is a POSIX-compliant _code(`true(1)') implementation in 0 bytes.
This was the _code(`true(1)') implementation on early versions of UNIX, including Research UNIX, System V, and Sun's Solaris, according to both Rob Pike and John Chambers.
A more explicit implementation also exists in POSIX shell:
</P>
<PRE>
#!/bin/sh
exit 0
</PRE>
<P>
This happens to be nearly identical in source to the implementation used by NetBSD.
</P>
<P>
Python has the same 0 byte _code(`true(1)') implementation feature as most shells.
Here's _code(`<I>false</I>(1)') in Python rather than _code(`true(1)') to demonstrate how exiting with an arbitrary exit status can be done:
</P>
<PRE>
import sys
sys.exit(1)
</PRE>
<P>
In some shells, _code(`true(1)') is a shell built-in command, so running _code(`true') will run the shell author's implementation of _code(`true(1)') rather than the system implementation.
</P>
<P>
GNU _code(`true(1)'), from the GNU coreutils, is well known for being a maximalist implementation - it's eighty lines long and directly includes four C header files.
Their _code(`true.c') is 2.3 kilobytes and parses the arguments _code(`--help') and _code(`--version') (only if either are the first argument to the program).
The GNU coreutils implementation of _code(`true(1)') is not POSIX compliant.
</P>

<H2>util-linux</H2>
<UL>
<LI><A HREF="https://en.wikipedia.org/wiki/Util-linux">util-linux - Wikipedia</A></LI>
</UL>
<P>
_code(`util-linux') is distributed on all popular Linux distributions and contains utilities users may expect to be already present on their systems, like _code(`more(1)') or _code(`hexdump(1)').
</P>

<H2>WiFi</H2>
<H3>wpa_supplicant</H3>
<P>
_code(`wpa_supplicant(1)') is usually good enough for establishing WiFi connections.
</P>
<P>
Here's an example configuration for a simple WPA-2 PSK access point.
</P>
<PRE>
network={
	ssid="My SSID"
	key_mgmt=WPA-PSK
	scan_ssid=1
	psk="My password"
}
</PRE>
<P>
See _code(`wpa_supplicant.conf(5)').
</P>

<H2>X</H2>
<UL>
<LI><A HREF="http://cyber.dabamos.de/unix/x11/">Cool, but obscure X11 tools</A></LI>
<LI><A HREF="https://wiki.archlinux.org/title/Xorg">Xorg</A> (Arch Wiki)</LI>
</UL>
<P>
X is a graphical windowing system that can be used on Linux, FreeBSD, OpenBSD, NetBSD, and some proprietary operating systems as well.
X is not the only windowing system; _code(`twin(1)') exists for windowed multitasking within a framebuffer and Wayland is another windowing system intended to replace X.
</P>
<P>
Xorg requires the user to be a member of the _code(`input') and _code(`video') groups (or superuser), otherwise it won't be able to access the relevent device files.
These errors look like _code(`Failed to open /dev/input/event[<I>number</I>] (Permission denied)') when not in the _code(`input') group
and _code(`Failed to open /dev/tty[<I>number</I>] (Permission denied)') when not in the _code(`video') group.
</P>
<P>
Some Linux software distributions have included scripts to automatically fetch and install an X server.
Alpine has _code(`setup-xorg-base'), which adds the packages _code(`xorg-server'), _code(`xf86-input-libinput'), _code(`eudev'), and _code(`mesa'), and then enables the OpenRC services for udev.
</P>
<P>
_code(`startx(1)') is provided as part of xinit.
</P>
<P>
Arch has the _code(`<A HREF="https://archlinux.org/groups/x86_64/xorg/">xorg</A>') and _code(`<A HREF="https://archlinux.org/groups/x86_64/xorg-apps/">xorg-apps</A>') package groups.
Documentation can be found within _code(`xorg-docs'),
drivers within the _code(`<A HREF="https://archlinux.org/groups/x86_64/xorg-drivers/">xorg-drivers</A>') package group,
the server itself as _code(`xorg-server'),
the X event monitor as _code(`xorg-xev'),
xinit as _code(`xorg-xinit'),
xinput as _code(`xorg-xinput'),
XRandR as _code(`xorg-xrandr'),
the X resource database manager as _code(`xorg-xrdb'),
xset as _code(`xorg-xset'),
and xsetroot as _code(`xorg-xsetroot').
</P>
<P>Alpine has xinput as _code(`xinput').</P>

<H3>Media</H3>
<P>
_code(`mpv(1)') and _code(`vlc(1)') are good options.
</P>

<H3>Window Management</H3>
<P>
It's possible to make X exec a window manager at the end of initialization to ease the creation, deletion, and manipulation of windows.
Contrary to what is now popular belief, window managers are not necessary (thought they're extremely convenient compared to the lack of them).
</P>
<H4>ctwm</H4>
<UL>
<LI><A HREF="https://datagubbe.se/twm/">Configurations for ctwm (and twm)</A></LI>
</UL>

<H3>Web Browsing</H3>
<H4>TOR Browser</H4>
<P>
TOR Browser is available through pkgsrc at _code(`security/tor-browser').
</P>

</BODY>
</HTML>
